package main

import (
	"sort"
	"fmt"
)
//实现sort的这个接口就能够排序了
//	type Interface interface {
//	// Len is the number of elements in the collection.
//	Len() int
//	// Less reports whether the element with
//	// index i should sort before the element with index j.
//	Less(i, j int) bool
//	// Swap swaps the elements with indexes i and j.
//	Swap(i, j int)
//}
type ByLength []string

func (s ByLength) Len() int {
	return len(s)
}

func (s ByLength) Swap(i, j int) {
	s[i], s[j] = s[j], s[i]
}

func (s ByLength) Less(i, j int) bool {
	return len(s[i]) < len(s[j])
}

func main(){
	fruit := []string{"peach", "banana", "kiwi"}
	sort.Sort(ByLength(fruit))
	fmt.Println(fruit)
}
